<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Ostvisit;

/**
 * OstvisitSearch represents the model behind the search form about `app\models\Ostvisit`.
 */
class OstvisitSearch extends Ostvisit
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['ost_visit_id', 'ost_visit_q2', 'ost_visit_q3', 'ost_visit_q4', 'create_time', 'create_user', 'update_time', 'update_user'], 'integer'],
            [['ost_visit_survey', 'ost_visit_part_id', 'ost_visit_q1', 'ost_visit_q6', 'ost_visit_q7','status','record_date'], 'safe'],
            [['ost_visit_q5'], 'number'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Ostvisit::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
			'sort'=>[
                'defaultOrder'=>['record_date'=> SORT_DESC],
            ],
        ]);
		if(empty($params))
            $params = Yii::$app->request->post();

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'ost_visit_id' => $this->ost_visit_id,
            'ost_visit_q2' => $this->ost_visit_q2,
            'ost_visit_q3' => $this->ost_visit_q3,
            'ost_visit_q4' => $this->ost_visit_q4,
            'ost_visit_q5' => $this->ost_visit_q5,
            'create_time' => $this->create_time,
            'create_user' => $this->create_user,
            'update_time' => $this->update_time,
            'update_user' => $this->update_user,
        ]);

        $query->andFilterWhere(['like', 'ost_visit_survey', $this->ost_visit_survey])
            ->andFilterWhere(['like', 'ost_visit_part_id', $this->ost_visit_part_id])
            ->andFilterWhere(['like', 'ost_visit_q1', $this->ost_visit_q1])
            ->andFilterWhere(['like', 'ost_visit_q6', $this->ost_visit_q6])
            ->andFilterWhere(['like', 'status', $this->status]);

        return $dataProvider;
    }
}
